﻿namespace TestProject;

/// <summary>
/// 프로그램
/// </summary>
class Program
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Static
    //////////////////////////////////////////////////////////////////////////////// Private

    #region 제곱근 계산하기 - CalculateRootSquare(source)

    /// <summary>
    /// 제곱근 계산하기
    /// </summary>
    /// <param name="source">소스 값</param>
    /// <returns>제곱근</returns>
    private static double CalculateRootSquare(double source)
    {
        if(source > 0)
        {
            double target = source / 3;

            int i;

            for(i = 0; i < 32; i++)
            {
                target = (target + source / target) / 2;
            }

            return target;
        }
        else
        {
            return double.NaN;
        }
    }

    #endregion
    #region 프로그램 시작하기 - Main()

    /// <summary>
    /// 프로그램 시작하기
    /// </summary>
    private static void Main()
    {
        Console.WriteLine($"CalculateRootSquare(2) : {CalculateRootSquare(2d)}");
        Console.WriteLine($"Math.Sqrt(2)           : {Math.Sqrt(2d)          }");
    }

    #endregion
}